desc "统计实践课程的学习统计数据"

namespace :subjects do
  task data_statistic: :environment do
    puts("---------------------data_statistic_begin")
    Rails.logger.info("---------------------data_statistic_begin")
    subjects = Subject.where(status: 2, hidden: 0)
    str = ""
    buffer_size = 0
    column_value = "subject_id, study_count, course_study_count, initiative_study, passed_count, course_used_count, " +
        "school_used_count, created_at, updated_at"
    subjects.find_in_batches(batch_size: 50) do |s, index|
      Parallel.each_with_index(s, in_processes: 4) do |subject|
        puts("---------------------data_statistic: #{subject.id}")
        Rails.logger.info("---------------------data_statistic: #{subject.id}")
        data = Subjects::DataStatisticService.new(subject)
        study_count = data.study_count
        next if study_count == 0
        course_study_count = data.course_study_count
        initiative_study = study_count - course_study_count
        str += ", " unless str.empty?
        str += ("(#{subject.id}, #{study_count}, #{course_study_count}, #{initiative_study}, " +
            "#{data.passed_count}, #{data.course_used_count}, #{data.school_used_count}, " +
            "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
        buffer_size += 1
        if buffer_size == 1000 || subjects.count == (index+1)
          sql = "REPLACE INTO subject_records(#{column_value}) VALUES #{str}"
          puts sql
          ActiveRecord::Base.connection.execute sql
          str = ""
          buffer_size = 0
        end
      end
    end

    puts("---------------------data_statistic_end")
    Rails.logger.info("---------------------data_statistic_end")
  end

  task course_info_statistic: :environment do
    puts("---------------------course_info_statistic_begin")
    Rails.logger.info("---------------------course_info_statistic_begin")
    subjects = Subject.where(status: 2, hidden: 0)
    str = ""
    buffer_size = 0
    column_value = "subject_id, school_id, school_name, course_count, student_count, choice_shixun_num, " +
        "choice_shixun_frequency, created_at, updated_at"

    subjects.find_in_batches(batch_size: 50) do |s|
      Parallel.each(s, in_processes: 4) do |subject|
        puts("---------------------course_info_statistic: #{subject.id}")
        Rails.logger.info("---------------------course_info_statistic: #{subject.id}")
        data = Subjects::CourseUsedInfoService.call(subject)
        Parallel.map_with_index(data) do |key, index|
          next if key[:school_id].nil?
          str += ", " unless str.empty?
          str += ("(#{subject.id}, #{key[:school_id]}, '#{key[:school_name]}', #{key[:course_count]}, " +
              "#{key[:student_count]}, #{key[:choice_shixun_num]}, #{key[:choice_shixun_frequency]}, " +
              "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
          buffer_size += 1
          if buffer_size == 1000 || (index + 1) == data.size
            sql = "REPLACE INTO subject_course_records(#{column_value}) VALUES #{str}"
            puts sql
            ActiveRecord::Base.connection.execute sql
            str = ""
            buffer_size = 0
          end
        end
      end
    end
    puts("---------------------course_info_statistic_end")
    Rails.logger.info("---------------------course_info_statistic_end")
  end

  task shixun_info_statistic: :environment do
    puts("---------------------shixun_info_statistic_begin")
    Rails.logger.info("---------------------shixun_info_statistic_begin")
    subjects = Subject.where(status: 2, hidden: 0)
    str = ""
    buffer_size = 0
    column_value = "subject_id, shixun_id, stage, shixun_name, challenge_count, course_count, " +
        "school_count, used_count, passed_count, evaluate_count, passed_ave_time, created_at, updated_at"
    subjects.find_in_batches(batch_size: 50) do |s|
      Parallel.each_with_index(s, in_processes: 4) do |subject|
        puts("---------------------shixun_info_statistic: #{subject.id}")
        Rails.logger.info("---------------------shixun_info_statistic: #{subject.id}")
        data = Subjects::ShixunUsedInfoService.call(subject)
        data.each_with_index do |key, index|
          next if key[:shixun_id].nil?
          str += ", " unless str.empty?
          str += ("(#{subject.id}, #{key[:shixun_id]}, '#{key[:stage]}', '#{key[:name]}', #{key[:challenge_count]}, " +
              "#{key[:course_count]}, #{key[:school_count]}, #{key[:used_count]}, #{key[:passed_count]}, " +
              "#{key[:evaluate_count]}, #{key[:passed_ave_time]}, " +
              "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
          buffer_size += 1
          if buffer_size == 1000 || (index+1) == data.size
            sql = "REPLACE INTO subject_shixun_infos(#{column_value}) VALUES #{str}"
            puts sql
            ActiveRecord::Base.connection.execute sql
            str = ""
            buffer_size = 0
          end
        end
      end
    end
    puts("---------------------shixun_info_statistic_end")
    Rails.logger.info("---------------------shixun_info_statistic_end")
  end

  task user_info_statistic: :environment do
    puts("---------------------user_info_statistic_begin")
    Rails.logger.info("---------------------user_info_statistic_begin")
    subjects = Subject.where(status: 2, hidden: 0)
    str = ""
    buffer_size = 0
    column_value = "user_id, subject_id, username, passed_myshixun_count, passed_games_count, " +
        "code_line_count, evaluate_count, cost_time, created_at, updated_at"

    subjects.find_in_batches(batch_size: 50) do |s|
      Parallel.each_with_index(s, in_processes: 4) do |subject, index|
        puts("---------------------user_info_statistic: #{subject.id}")
        data = Subjects::UserUsedInfoService.call(subject)
        data.each do |key|
          next if key[:user_id].nil?
          str += ", " unless str.empty?
          str += ("(#{key[:user_id]}, #{subject.id}, '#{key[:name].gsub(/'/, '"')}', #{key[:passed_myshixun_count]}, " +
              "#{key[:passed_games_count]}, #{key[:code_line_count]}, #{key[:evaluate_count]}, #{key[:cost_time]}, " +
              "'#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}', '#{Time.now.strftime('%Y-%m-%d %H:%M:%S')}')")
          buffer_size += 1
          if buffer_size == 1000 || (index+1 == data.size)
            sql = "REPLACE INTO subject_user_infos(#{column_value}) VALUES #{str}"
            ActiveRecord::Base.connection.execute sql
            str = ""
            buffer_size = 0
          end
        end
      end
    end
    puts("---------------------user_info_statistic_end")
    Rails.logger.info("---------------------user_info_statistic_end")
  end



  end
